> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.ntropy.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ntropy.com/_mcp/server.

# Replace all rules

POST https://api.ntropy.com/v3/rules/replace
Content-Type: application/json

Replace all rules

Reference: https://docs.ntropy.com/documentation/api/personalization/filter-replace-v-3-rules-replace-post

## Authentication

- `X-Api-Key` header (required) — API Key authentication via header

## Request

### Body (application/json)

This endpoint expects a list of Action.

- `list of Action`

## Response

### 200

Successful Response

- `any`

## Errors

### 400 Bad Request Error

Provided ruleset has invalid structure

- `any`

### 413 Content Too Large Error

Ruleset was larger than 50KiB

- `any`

### 422 Unprocessable Entity Error

Validation Error

- `detail` (list of ValidationError, optional)

## Types

### Action

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### If

- `if` (Expr, required)
- `then` (list of Action, optional)
- `else` (list of Action, optional)

### Setter

- `set` (enum, required)
  - Allowed values: `logo`, `website`, `merchant`, `merchant_id`, `location`, `person`, `transaction_type`
- `to` (Expr, required)

### ValidationErrorLocItems

### Expr

## Examples

**Request**

```json
[
  {
    "if": {},
    "then": [
      {
        "set": "logo",
        "to": "http://example.com/favicon.ico"
      }
    ],
    "else": [
      {
        "remove_label": "example label"
      }
    ]
  }
]
```

**SDK Code**

```python Python SDK
from ntropy_sdk import SDK

sdk = SDK("cd1H...Wmhl")
rules = sdk.rules.replace(
    [
        {
            "if": {"is_substring": [{"get": "website"}, "ntropy"]},
            "then": [{"set": "logo", "to": "http://example.com/favicon.ico"}],
            "else": [{"remove_label": "example label"}],
        }
    ]
)
```

```javascript
const url = 'https://api.ntropy.com/v3/rules/replace';
const options = {
  method: 'POST',
  headers: {'X-Api-Key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '[{"if":{},"then":[{"set":"logo","to":"http://example.com/favicon.ico"}],"else":[{"remove_label":"example label"}]}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.ntropy.com/v3/rules/replace"

	payload := strings.NewReader("[\n  {\n    \"if\": {},\n    \"then\": [\n      {\n        \"set\": \"logo\",\n        \"to\": \"http://example.com/favicon.ico\"\n      }\n    ],\n    \"else\": [\n      {\n        \"remove_label\": \"example label\"\n      }\n    ]\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Api-Key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.ntropy.com/v3/rules/replace")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Api-Key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"if\": {},\n    \"then\": [\n      {\n        \"set\": \"logo\",\n        \"to\": \"http://example.com/favicon.ico\"\n      }\n    ],\n    \"else\": [\n      {\n        \"remove_label\": \"example label\"\n      }\n    ]\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.ntropy.com/v3/rules/replace")
  .header("X-Api-Key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"if\": {},\n    \"then\": [\n      {\n        \"set\": \"logo\",\n        \"to\": \"http://example.com/favicon.ico\"\n      }\n    ],\n    \"else\": [\n      {\n        \"remove_label\": \"example label\"\n      }\n    ]\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.ntropy.com/v3/rules/replace', [
  'body' => '[
  {
    "if": {},
    "then": [
      {
        "set": "logo",
        "to": "http://example.com/favicon.ico"
      }
    ],
    "else": [
      {
        "remove_label": "example label"
      }
    ]
  }
]',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Api-Key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.ntropy.com/v3/rules/replace");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Api-Key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"if\": {},\n    \"then\": [\n      {\n        \"set\": \"logo\",\n        \"to\": \"http://example.com/favicon.ico\"\n      }\n    ],\n    \"else\": [\n      {\n        \"remove_label\": \"example label\"\n      }\n    ]\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Api-Key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "if": [],
    "then": [
      [
        "set": "logo",
        "to": "http://example.com/favicon.ico"
      ]
    ],
    "else": [["remove_label": "example label"]]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.ntropy.com/v3/rules/replace")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```